package de.hhhammer.dchat.bot.openai.models;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;

import java.util.List;

@JsonIgnoreProperties(ignoreUnknown = true)
public record ChatGPTResponse(String id,
                              String object,
                              long created,
                              String model,
                              Usage usage,
                              List<Choice> choices,
                              @JsonProperty("system_fingerprint") String systemFingerprint) {

    @JsonIgnoreProperties(ignoreUnknown = true)
    public record Usage(@JsonProperty("prompt_tokens") int promptTokens,
                        @JsonProperty("completion_tokens") int completionTokens,
                        @JsonProperty("total_tokens") int totalTokens) {
    }

    @JsonIgnoreProperties(ignoreUnknown = true)
    public record Choice(Message message, @JsonProperty("finish_reason") String finishReason, int index) {
        public record Message(String role, String content) {
        }

    }
}
